/*********************************************************************
 * Copyright (c) 2022 CEA (Commissariat à l'énergie atomique et aux énergies alternatives)
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 **********************************************************************/
package max.core.inspection.exporter;

import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Map;
import java.util.logging.Logger;
import max.core.InMemoryHandler;
import max.core.inspection.DataInspector;
import max.core.inspection.Exporter;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.io.TempDir;

/**
 * Collection of tests related to {@link FileExporter}.
 *
 */
public class FileExporterTest {

    /**
     * A simple {@link FileExporter} supporting {@link String} export.
     *
     * @author Pierre Dubaillay
     */
    private static final class DummyFileExporter extends FileExporter<String> {

        private static final Logger LOGGER = Logger.getLogger(DummyFileExporter.class.getCanonicalName());

        /**
         * Given an owner and a file path, create a new instance.
         *
         * @param filePath where data is stored
         */
        private DummyFileExporter(DataInspector owner, Path filePath, Map<String, Object> metadata) {
            super(filePath, metadata);
        }

        @Override
        protected void writeMetadata(Map<String, Object> metadata) {
            // Nothing
        }

        @Override
        public void export(String data) {
            writeData(data);
        }

      @Override
      protected Logger getLogger() {
        return LOGGER;
      }
    }

    /**
     * Make sure data is written within the time the exporter is "active" ({@link Exporter#activate()} is called but
     * not {@link Exporter#end()}.
     *
     * @param tempDir temporary directory generated by JUnit
     * @throws IOException if something bad happens while reading the created file (test error)
     */
    @Test
    public void dataIsWritten(@TempDir Path tempDir) throws IOException {
        final var file = tempDir.resolve("the_file.txt");
        final var inspector = new DataInspector();
        final var exporter = new DummyFileExporter(inspector, file, Map.of());

        final var notInFile = "Not in file";
        exporter.export(notInFile);
        assertFalse(Files.exists(file));

        exporter.activate();
        assertTrue(Files.exists(file) && Files.isRegularFile(file));

        final var msg = "Hello World!";
        exporter.export(msg);
        exporter.end();  // Should close and flush buffer into file
        assertTrue(Files.readAllLines(file).contains(msg));

        exporter.export(notInFile);
        assertFalse(Files.readAllLines(file).contains(notInFile));
    }

    /**
     * Make sure the exporter is not trying to write data if the file couldn't be opened.
     *
     * @param tempDir Temporary folder created by JUnit
     */
    @Test
    public void errorAtOpening(@TempDir Path tempDir) {
        final var inspector = new DataInspector();
        final var exporter = new DummyFileExporter(inspector, tempDir, Map.of());

        // Configure logger so we can retrieve produced logs
        final var handler = new InMemoryHandler();
        Logger.getLogger(DummyFileExporter.class.getCanonicalName()).addHandler(handler);

        exporter.activate();
        assertFalse(handler.getRecordedLogs().isEmpty());
        assertTrue(handler.getRecordedLogs().get(0).contains("Unable to create file"));
    }
}
